unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DB, SqlExpr, Grids, DBGrids,
  dbexpca400, StdCtrls, Provider, DBClient, ExtCtrls, DBCtrls, ComCtrls,
  Buttons;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DataSetProvider1: TDataSetProvider;
    ExecQuery: TSQLQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    CreateQueryMemo: TMemo;
    InsertMemo: TMemo;
    Panel1: TPanel;
    Label3: TLabel;
    edTableName: TEdit;
    Label5: TLabel;
    edId: TEdit;
    edInsString: TEdit;
    Label2: TLabel;
    edLeadByte: TEdit;
    Label6: TLabel;
    GenInsStringBtn: TSpeedButton;
    GenBig5Btn: TSpeedButton;
    InsBtn: TSpeedButton;
    edBig5String: TEdit;
    Label4: TLabel;
    Panel2: TPanel;
    SelectQueryMemo: TMemo;
    OpenBtn: TSpeedButton;
    CreateBtn: TSpeedButton;
    DropBtn: TSpeedButton;
    ClearBtn: TSpeedButton;
    DBNavigator1: TDBNavigator;
    ApplyBtn: TSpeedButton;
    procedure OpenBtnClick(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure GenBig5BtnClick(Sender: TObject);
    procedure GenInsStringBtnClick(Sender: TObject);
    procedure InsBtnClick(Sender: TObject);
    procedure DropBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.OpenBtnClick(Sender: TObject);
Var
  i: Integer;
begin
  Screen.Cursor:= crHourGlass;
  Try
    ClientDataset1.Active:= False;
    SQLQuery1.SQL.Text:= Format(SelectQueryMemo.Text, [edTableName.Text]);
    ClientDataset1.Active:= True;
    For i:= 0 To DBGrid1.Columns.Count-1 Do
      If (Pos('TC', UpperCase(DBGrid1.Columns[i].FieldName))>0) Then Begin
        DBGrid1.Columns[i].Font.Name:= 'MS Sans Serif';
        DBGrid1.Columns[i].Font.Charset:= CHINESEBIG5_CHARSET;
      End;
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.CreateBtnClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= Format(CreateQueryMemo.Text, [edTableName.Text]);
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Table created', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Creation failed', mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.GenBig5BtnClick(Sender: TObject);
Var
  S: String;
  i: Integer;
  Lead: Char;
begin
  S:= '';
  Lead:= Char(StrToInt(edLeadByte.Text));
  For i:= $40 To $FE Do
    S:= S+Lead+Char(i);
  edBig5String.Text:= S
end;

procedure TForm1.GenInsStringBtnClick(Sender: TObject);
Var
  S: String;
  i: Integer;
begin
  S:= '';
  For i:= 32 To 255 Do
    S:= S+Char(i);
  edInsString.Text:= S
end;

procedure TForm1.InsBtnClick(Sender: TObject);
Var
  Count: Integer;
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= Format(InsertMemo.Text, [edTableName.Text]);
    ExecQuery.ParamByName('id').AsInteger:= StrToInt(edID.Text);
    ExecQuery.ParamByName('InsString').AsString:= edInsString.Text;
    ExecQuery.ParamByName('Big5String').AsString:= edBig5String.Text;
    Count:= ExecQuery.ExecSQL;
    MessageDlg(Format('%d rows affected', [Count]), mtInformation, [mbOk], 0);
    edID.Text:= IntToStr(StrToInt(edID.Text)+1)
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.DropBtnClick(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= Format('Drop Table %s', [edTableName.Text]);
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Table dropped', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Drop failed', mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

function CodePageToWideString(A: AnsiString; CodePage: Word): WideString;
begin
  SetLength(Result, Length(A));
  MultiByteToWideChar(CodePage, 0, PChar(A), Length(A), PWideChar(Result), Length(A) * 2 +2);
end;


procedure TForm1.ClearBtnClick(Sender: TObject);
Var
  Count: Integer;
begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= Format('Delete From %s', [edTableName.Text]);
    Count:= ExecQuery.ExecSQL;
    MessageDlg(Format('%d rows affected', [Count]), mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.ApplyBtnClick(Sender: TObject);
begin
  ClientDataSet1.ApplyUpdates(0)
end;

end.
