unit StoredProcMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DB, SqlExpr, Grids, DBGrids,
  dbexpca400, StdCtrls, Provider, DBClient, ExtCtrls, DBCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    SQLConnection1: TSQLConnection;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DataSetProvider1: TDataSetProvider;
    ExecQuery: TSQLQuery;
    SQLStoredProc1: TSQLStoredProc;
    Panel1: TPanel;
    Label5: TLabel;
    edProcName: TEdit;
    CreateBtn: TButton;
    DropBtn: TButton;
    Label4: TLabel;
    Label8: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    ExecSQLBtn: TButton;
    Label2: TLabel;
    edParm3: TEdit;
    Label7: TLabel;
    Label6: TLabel;
    edParm2: TEdit;
    edParm1: TEdit;
    Label3: TLabel;
    Splitter2: TSplitter;
    SQLPageControl: TPageControl;
    SQLTab: TTabSheet;
    CLTab: TTabSheet;
    RPGTab: TTabSheet;
    SQLProcMemo: TMemo;
    CLProcMemo: TMemo;
    RPGProcMemo: TMemo;
    ExecCLProc: TButton;
    Label9: TLabel;
    edArg: TEdit;
    edRes: TEdit;
    Label10: TLabel;
    procedure ExecSQLBtnClick(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure DropBtnClick(Sender: TObject);
    procedure SQLPageControlChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExecCLProcClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CreateBtnClick(Sender: TObject);
Var
  s: String;
  p: Integer;
Begin
  Screen.Cursor:= crHourGlass;
  Try
    // put appropriate query text for SP creation into ExecQuery...
    If SQLPageControl.ActivePage=SQLTab Then     s:= SQLProcMemo.Text
    Else If SQLPageControl.ActivePage=CLTab Then s:= CLProcMemo.Text
    Else                                         s:= RPGProcMemo.Text;

    // ... remove unnecessary comments ...
    p:= Pos('/*', s);
    If p>0 Then s:= Copy(s, 1, p-1);
    ExecQuery.SQL.Text:= Format(s, [edProcName.Text]);

    // ... and execute the SQL to create the SP
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Procedure created', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Procedure creation failed', mtInformation, [mbOk], 0);
  Finally
    Screen.Cursor:= crDefault
  End
end;

procedure TForm1.DropBtnClick(Sender: TObject);
Begin
  Screen.Cursor:= crHourGlass;
  Try
    ExecQuery.SQL.Text:= 'drop procedure '+edProcName.Text;
    If ExecQuery.ExecSQL>=0 Then
      MessageDlg('Procedure dropped', mtInformation, [mbOk], 0)
    Else
      MessageDlg('Procedure drop failed', mtInformation, [mbOk], 0)
  Finally
    Screen.Cursor:= crDefault
  End
end;


procedure TForm1.SQLPageControlChange(Sender: TObject);
begin
  CreateBtn.Caption:= Format('Create %s', [SQLPageControl.ActivePage.Caption]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLPageControl.ActivePage:= SQLTab;
  SQLPageControlChange(Self);
end;

procedure TForm1.ExecSQLBtnClick(Sender: TObject);
begin
  ClientDataset1.Active:= False;
  ClientDataset1.Params.Clear;
  SQLStoredProc1.StoredProcName:= UpperCase(edProcName.Text);
  SQLStoredProc1.ParamByName('Parm1').AsString:= edParm1.Text;
  SQLStoredProc1.ParamByName('Parm3').AsInteger:= StrToInt(edParm3.Text);
  ClientDataset1.Active:= True;
  // there is a bug in SqlExpr/Midas that makes it loose the "input" parameters
  ClientDataset1.Params.Clear; // this is because of a bug in SqlExpr.pas
  edParm1.Text:= SQLStoredProc1.ParamByName('Parm1').AsString;
  edParm2.Text:= SQLStoredProc1.ParamByName('Parm2').AsString;
  edParm3.Text:= SQLStoredProc1.ParamByName('Parm3').AsString;
end;

procedure TForm1.ExecCLProcClick(Sender: TObject);
begin
  ClientDataset1.Active:= False; // just in case it was used before
  SQLStoredProc1.StoredProcName:= UpperCase(edProcName.Text);
  SQLStoredProc1.ParamByName('Arg').AsInteger:= StrToInt(edArg.Text);
  SQLStoredProc1.ExecProc;
  edArg.Text:= IntToStr(SQLStoredProc1.ParamByName('Arg').AsInteger);
  edRes.Text:= IntToStr(SQLStoredProc1.ParamByName('Res').AsInteger);
end;

end.
